#
# spec file for package 
#
# Copyright (c) 2013 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

#NOTE(saschpe): Macro only exists on 13.1 or later:
%{!?_tmpfilesdir:%global _tmpfilesdir /usr/lib/tmpfiles.d}

Name:           btsync
Version:        1.3.106
Release:        3.1
License:        BitTorrent
URL:            http://www.bittorrent.com/sync
Summary:        BitTorrent Sync           
Group:          System/Daemons
Source0:        install-%{name}.sh
Source1:        %{name}@.service
Source2:        %{name}-tmpfiles.d.conf
Source3:        %{name}-wrapper
BuildRequires:  systemd > 42
%{?systemd_requires}

#NOTE(saschpe): btsync uses GLIBC_PRIVATE symbols and there's nothing we can do about it:
%define __filter_GLIBC_PRIVATE 1

%description
BitTorrent Sync allows you to synchronize an unlimited number folders and files of any size across multiple devices.

%prep

%build

%install
# Install app wrapper
install -D -m755 %{SOURCE3} %{buildroot}%{_bindir}/btsync-wrapper
install -d -m755 %{buildroot}/var/lib/%{name}
# Install services
install -d -m755 %{buildroot}%{_sbindir}
ln -s service %{buildroot}%{_sbindir}/rcbtsync
install -D -m644 %{SOURCE1} %{buildroot}%{_unitdir}/%{name}@.service
# Tmpfiles.d configuration to create /run/btsync
install -D -m0644 %{SOURCE2} %{buildroot}%{_tmpfilesdir}/%{name}.conf
# NOTE(saschpe): Make 12.2's build-checks happy:
install -d -m755 %{buildroot}/run/%{name}
# Install fetch script
install -D -m755 %{SOURCE0} %{buildroot}%{_prefix}/lib/%{name}/install-btsync.sh
echo "%{version}" > %{buildroot}%{_prefix}/lib/%{name}/version.txt
# Prepare documentation directory (will be fetched in scriptlets)
mkdir -p %{buildroot}%{_docdir}/btsync
# touch
mkdir -p %{buildroot}%{_sysconfdir}
touch %{buildroot}%{_sysconfdir}/btsync.conf
touch %{buildroot}%{_bindir}/btsync
touch %{buildroot}%{_docdir}/btsync/LICENSE.TXT

%pre
%service_add_pre %{name}@.service

%post
%service_add_post %{name}@.service
systemd-tmpfiles --create /usr/lib/tmpfiles.d/%{name}.conf
#TODO(saschpe): Get rid of old service file
%{_prefix}/lib/%{name}/install-btsync.sh || :

%preun 
%service_del_preun %{name}@.service

%postun
%service_del_postun %{name}@.service

%files
%defattr(-,root,root)
%ghost %config(noreplace) %{_sysconfdir}/btsync.conf
%ghost %attr(0755, root, root) %{_bindir}/btsync
%dir %{_docdir}/btsync
%ghost %{_docdir}/btsync/LICENSE.TXT
%{_bindir}/btsync-wrapper
%{_sbindir}/rcbtsync
%{_unitdir}/%{name}@.service
%{_tmpfilesdir}/%{name}.conf
%dir /var/lib/%{name}
%ghost /run/%{name}
%{_prefix}/lib/%{name}

%changelog
* Mon Jun 30 2014 saschpe@gmx.de
- Update to verison 1.4.106:
  + Fixed issue with inability to type in path manually in WebUI
  + Indexing is shown in WebUI when BTSync indexes files
  + Overwrite checkbox brought back for RO secrets in WebUI
  + Fixed issue with "#" symbol in the folder picker in WebUI
  + Fixed issue with encrypted secret not displayed in WebUI
  + Fixed issue with short / long path shown in WebUI
  + Fixed LAN discovery issue when many folders and files are added to sync dirs
  + Fixed continual indexing issue in certain cases
  + Minor cosmetic fixes
* Mon Jun  2 2014 saschpe@mailbox.org
- Defer installation of the btsync binary to install time (in RPM %%post
  scriptlet) to comply with the licensing terms
* Mon Jun  2 2014 saschpe@mailbox.org
- Update to version 1.3.105:
  + WebUI redesigned
  + Fixed issues causing app crash
* Wed May 28 2014 saschpe@mailbox.org
- Change /var/run/btsync to /run/btsync
* Mon May  5 2014 speilicke@suse.com
- Update to version 1.3.94:
  + Various crash fixes
* Thu Mar 27 2014 speilicke@suse.com
- Update to version 1.3.67:
  + Support TCP connectivity between peers, tracker and relay (work when UDP is not available)
  + Greatly reduced parasite traffic when between peers, tracker and during LAN search
  + Improved behaviour with case-insensitive file systems (rename correctly)
  + Extended attributes (OS X) and file streams (Windows) support
  + Improved getting started assistant
  + Sync notifications redesigned
  + New advanced option: external (NAT) port can be configured
  + Optimized folder indexing
  + Added log rotation
  + Fixed issue with permissions transfer on Linux and Mac during initial scan
  + Fixed issue with sync getting stuck after folder removal
  + Fixed issue when deleted files get restored after peer comes online
  + Fixed issue when new version not checked on Linux and FreeBSD
  + Fixed replacing invalid chars with "_" after sync
  + Fixed sync stuck issue due to case-sensitive rename
  + Fixed indexing hang when unable to access folder due to permissions
  + Fixed sync hang due to network change until app restart
  + Fixed Linux executable attribute loss when file modified on Windows PC
  + Fixed app crash when entering invalid secret
  + Added log rotation value in Advanced preferences
  + Fixed several issues with freeze on Mac
  + Fixed missing notifications
  + Fixed issue with updates on Linux
  + Added tooltips in Devices tab on Windows
  + Fixed occasional app crashes
  + Fixed stream appearing as file.com.apple.metadata after updating 1.2.91.
  + Fixed issue with executable flag dropped after merging changes from win client to linux client
  + Fixed issue with merging files tree
  + Fixed issue with file moved to .SyncArchive after renaming (change case of letter).
  + Fixed app hang when trying close app.
  + Fixed check-for-updates issue on Mac
  + Fix for Linux sync issue
  + Fix for the crash on encrypted node
  + Cosmetic fixes and changes
  + UI improvements
  + See http://forum.bittorrent.com/topic/28597-bittorrent-sync-13/
- Move to systemd service template that can be run for multiple users and add a
  wrapper script that creats suitable configuration for both root and non-root
  users
* Tue Mar 18 2014 speilicke@suse.com
- Update to version 1.2.92:
  + Bugfixes
  + Compatibility with 1.3
* Thu Dec 19 2013 speilicke@suse.com
- Secure permissions for /etc/btsync.conf
* Tue Dec 17 2013 speilicke@suse.com
- Conditionally define %%_tmpfilesdir for openSUSE < 13.1
- Have /var/run/btsync in build-root to pleae post-build-checks on 12.2
* Tue Dec 17 2013 speilicke@suse.com
- Initial version:
  + Add systemd service
  + Use tmpfiles.d for /var/run/btsync
